unit U_Berechnung;

interface
 var Clip_L,Clip_R,Clip_O,Clip_U,Scheiben:integer;
     ZPlane_top:integer;

 Function  Circle_Angle_Calculate(xk,yk:real):real;            //G2 G3 Winkel berechnen
 Procedure Linear_Move(GNr:integer);                                        //Geraden-Interpolation
 Procedure CircleR_Move;                                       //Kreis-Interpolation
 Procedure CircleL_Move;                                       //Kreis-Interpolation
 Procedure G81;                                                //Bohrzyklus
 Procedure Quarter_Segment_Init;                               //Viertelkreis berechnen
 Procedure Quarter_Segment_Cylinder(xi,yi:integer;zi:integer); //Virtelkreis Zylinder
 Procedure Quarter_Segment_Ball(xi,yi:integer;zi:integer);     //Viertelkreis Kugel
 Procedure Circle_Check(xi,yi:integer;xii,yii:integer;zii:longint;sl:integer);//Vergleichen mit Kontur_arr
 Procedure Tool_GT_Check(zi:integer);
 Procedure Tool_SL_Check(xf,yf,zii,sl:integer);

implementation

uses U_2DFenster, U_ZeileLesen, U_Infos, U_ReadToolFile;

Procedure Quarter_Segment_Init;
var RZylinder,REcke,REcke_Q,c,temp,Radius,Radius_Q,tan:real;
    Clip_Radius,a,b:integer;
Begin
 Clip_Radius:=round(ToolTab[T].D*scalf+1);
 Clip_R:=xschleife+Clip_Radius;Clip_L:=-Clip_Radius;
 Clip_O:=yschleife+Clip_Radius;Clip_U:=-Clip_Radius;
 for a:=0 to Clip_Radius do for b:= 0 to Clip_Radius do Disk_arr[a,b]:=0;
 Radius:=ToolTab[T].D*scalf;
 Radius_Q:=sqr(Radius);
 Scheiben:=round(Radius);
 RZylinder:=(ToolTab[T].D-ToolTab[T].R)*scalf; //zylindr. Teil bei Eckradius
 REcke:=ToolTab[T].R*scalf;                     //Eckradius
 REcke_Q:=sqr(REcke);

 if(ToolTab[T].Form>=0)and(ToolTab[T].Form<=3)then
 begin
   for a:=0 to Scheiben do
   begin
    if a=0 then Disk_end[a]:=Scheiben else
    begin
     temp:=Radius_Q-sqr(a);
     if temp<=0.00000001 then Disk_end[a]:=0 else Disk_end[a]:=round(sqrt(temp));
    end;
    for b:=0 to Disk_end[a] do
    begin
     if REcke=0 then Disk_arr[a,b]:=0 else
     begin
       c:=sqr(a)+sqr(b);
      if c<=0.00000001 then c:=0 else c:=sqrt(c);
      if c-RZylinder<=0.00000001
       then Disk_arr[a,b]:=0
       else
       begin
        temp:=REcke_Q-sqr(c-RZylinder);
        if temp<=0then Disk_arr[a,b]:=round(REcke*Z_Factor) else
                       Disk_arr[a,b]:=round((REcke-sqrt(temp))*Z_Factor);
       end;
     end;
    end;
   end;
 end else
 if ToolTab[T].Form=4 then
 begin
   {if ToolTab[T].Form=4 then tan:=Sin(50*(pi/180)) / Cos(50*(pi/180));
   if ToolTab[T].Form=5 then tan:=Sin(50*(pi/180)) / Cos(50*(pi/180));
   if ToolTab[T].Form=6 then tan:=Sin(30*(pi/180)) / Cos(30*(pi/180)); }
   tan:=Sin(ToolTab[T].Grad/2*(pi/180)) / Cos(ToolTab[T].Grad/2*(pi/180));
   for a:=0 to Scheiben do
   begin
     temp:=Radius_Q-sqr(a);
     if temp<=0.00000001 then Disk_end[a]:=0 else Disk_end[a]:=round(sqrt(temp));
     for b:=0 to Disk_end[a] do
     begin
       temp:=sqr(a)+sqr(b);
       if temp<=0.00000001 then Disk_arr[a,b]:=0 else
                                Disk_arr[a,b]:=round((sqrt(temp) / tan) * Z_Factor);
     end;
   end;
 end;
end;
//------------------------------ Viertelkreis Kugel Zylinder ---------------------------------------------
Procedure Tool_GT_Check(zi:integer);
begin
 //if zNp-Zorg > ToolTab[T].GTist then ToolTab[T].GTist:=zNp-Zorg;
 {---Z:=((ZOrg-zNp)*scalf);---}
// ToolTab[T].use:=true; fehlerhaft
 if -zi  > ToolTab[T].GTist then ToolTab[T].GTist:=-zi;
end;

Procedure Quarter_Segment_Cylinder(xi,yi:integer;zi:integer);
var a,b,sl:integer;
Begin
 if zi<=ZPlane_Top{0} then if(XI>Clip_L)and(XI<Clip_R)and(YI>Clip_U)and(YI<Clip_O)then
 if Scheiben>0 then
 begin
  for a:=0 to Scheiben-1 do for b:=Disk_end[a+1] to Disk_end[a]do
         Circle_Check(xi,yi,a,b,zi+Disk_arr[a,b],1);
  for b:=0 to Disk_end[Scheiben]do
         Circle_Check(xi,yi,a,b,zi+Disk_arr[a,b],1);
 end else Circle_Check(xi,yi,0,0,zi,1);
end;

Procedure Quarter_Segment_Ball(xi,yi:integer;zi:integer);
var a,b:integer;
Begin
 if zi<=ZPlane_Top{0} then if(XI>Clip_L)and(XI<Clip_R)and(YI>Clip_U)and(YI<Clip_O)
 then
 begin
 for a:=0 to Scheiben do for b:=0 to Disk_end[a]do
      if zi+Disk_arr[a,b]<=0 then
      begin
        if a<Scheiben then
        begin
          if b>=Disk_end[a+1]then Circle_Check(xi,yi,a,b,zi+Disk_arr[a,b],1)
                             else Circle_Check(xi,yi,a,b,zi+Disk_arr[a,b],0);
        end else
        begin
          Circle_Check(xi,yi,a,b,zi+Disk_arr[a,b],1)
        end;
      end else break;
 end;
end;

Procedure Tool_SL_Check(xf,yf,zii,sl:integer);
begin
 if (x<>xold)or(y<>yold)then
 if sl=1 then
 if Kontur_arr[yf,xf] - zii  > ToolTab[T].GSList
   then ToolTab[T].GSList:=Kontur_arr[yf,xf] - zii;
end;

//---------------------------- Kreistest -----------------------------------------------------------------
Procedure Circle_Check(xi,yi:integer;xii,yii:integer;zii:longint;sl:integer);
var xf,yf:integer;
begin
 if Crash_Check then
 begin
  xf:=xi+xii;yf:=yi+yii;
    if (yf>=0)and(yf<=yschleife)and(xf>=0)and(xf<=xschleife)then
    if zii<Kontur_arr[yf,xf]then F_2D.Point_Crash(xf,yf,zii);
  xf:=xi-xii;
    if (yf>=0)and(yf<=yschleife)and(xf>=0)and(xf<=xschleife)then
    if zii<Kontur_arr[yf,xf]then F_2D.Point_Crash(xf,yf,zii);
  yf:=yi-yii;
    if (yf>=0)and(yf<=yschleife)and(xf>=0)and(xf<=xschleife)then
    if zii<Kontur_arr[yf,xf]then F_2D.Point_Crash(xf,yf,zii);
  xf:=xi+xii;
    if (yf>=0)and(yf<=yschleife)and(xf>=0)and(xf<=xschleife)then
    if zii<Kontur_arr[yf,xf]then F_2D.Point_Crash(xf,yf,zii);
 end else
 begin
 xf:=xi+xii;yf:=yi+yii;
    if (yf>=0)and(yf<=yschleife)and(xf>=0)and(xf<=xschleife)then
    if (zii<Kontur_arr[yf,xf])then
    begin  Tool_SL_Check(xf,yf,zii,sl);
           F_2D.Point_Contour(xf,yf,zii);
    end;
  xf:=xi-xii;
    if (yf>=0)and(yf<=yschleife)and(xf>=0)and(xf<=xschleife)then
    if (zii<Kontur_arr[yf,xf])then
    begin Tool_SL_Check(xf,yf,zii,sl);
          F_2D.Point_Contour(xf,yf,zii);
    end;
  yf:=yi-yii;
    if (yf>=0)and(yf<=yschleife)and(xf>=0)and(xf<=xschleife)then
    if (zii<Kontur_arr[yf,xf])then
    begin Tool_SL_Check(xf,yf,zii,sl);
          F_2D.Point_Contour(xf,yf,zii);
    end;
  xf:=xi+xii;
    if (yf>=0)and(yf<=yschleife)and(xf>=0)and(xf<=xschleife)then
    if (zii<Kontur_arr[yf,xf])then
    begin  Tool_SL_Check(xf,yf,zii,sl);
           F_2D.Point_Contour(xf,yf,zii);
    end;
 {end;}
 end;
end;

// --------- -------------------- G81 PROCEDURE ----------------------------------------------------------
PROCEDURE G81;
var xi,yi,zi:integer;
begin
   xi:=round(X); yi:=round(Y); zi:=round(SA*Z_Factor);
   Crash_Check:=true;  Quarter_Segment_Ball(xi,yi,zi);

   xi:=round(X); yi:=round(Y); zi:=round(TA*Z_Factor);
   Crash_Check:=false; Quarter_Segment_Ball(xi,yi,zi);
   if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);
Tool_GT_Check(zi);
end;
// --------- -------------------- Linear_Move PROCEDURE --------------------------------------------------
PROCEDURE Linear_Move(GNr:integer);
var xi,yi,zi,ziTemp,m,r_xold,r_yold,r_zold,r_xa,r_ya,r_za,r_X,r_Y,r_Z,
    mEnd:longint;
    xa,ya,za,stepx,stepy,stepz:real;
begin
 stepz:=0;
 xa:=x-xold;  if xa<0 then xa:=-xa;  if xa=0 then xa:=1;
 ya:=y-yold;  if ya<0 then ya:=-ya;  if ya=0 then ya:=1;
 za:=z-zold;  if za<0 then za:=-za;  if za=0 then za:=1;
 r_xold:=round(xold);  r_yold:=round(yold);  r_zold:=round(zold);
 r_x:=round(x);        r_y:=round(y);        r_z:=round(z);
 r_xa:=round(xa);      r_ya:=round(ya);      r_za:=round(za);

 Tool_GT_Check(round(Z*Z_Factor));
 if(GNr=1)or(GNr=0)then
 begin
   if (x=xold)and(y=yold)then
   begin
     xi:=r_X;  yi:=r_Y;  zi:=round(Z*Z_Factor);
     Quarter_Segment_Ball(xi,yi,zi);
     if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);
   end else
   begin
     if (r_xa>=r_ya) and (r_xa>=r_za) then
     begin
       if r_xa      =0 then stepy:=r_y-r_yold else stepy:=(r_y-r_yold)/r_xa;
       if r_xa      =0 then stepz:=Z-Zold     else stepz:=(Z-Zold)/r_xa;
       if r_x-r_xold<0 then stepx:=-1         else stepx:=1;
       if r_xa>0 then
       begin
         if Z=Zold then
         begin
           zi:=round(Z*Z_Factor);
           for m:=0 to r_xa do
           begin
             xi:=r_xold+round(stepx*m);
             yi:=r_yold+round(stepy*m);
             if ToolTab[T].Form=1 then Quarter_Segment_Cylinder(xi,yi,zi)
                                  else Quarter_Segment_Ball(xi,yi,zi);
             {if ToolTab[T].R=0 then Quarter_Segment_Cylinder(xi,yi,zi)
                               else Quarter_Segment_Ball(xi,yi,zi);}
             if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);
           end;
         end else
         begin
           for m:=0 to r_xa-1 do
           begin
             xi:=r_xold+round(stepx*m);
             yi:=r_yold+round(stepy*m);
             zi:=round((zold+stepz*m)*Z_Factor);
             {if ToolTab[T].R=0 then Quarter_Segment_Cylinder(xi,yi,zi)
                               else Quarter_Segment_Ball(xi,yi,zi);}
             if ToolTab[T].Form=1 then Quarter_Segment_Cylinder(xi,yi,zi)
                                  else Quarter_Segment_Ball(xi,yi,zi);
             if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);
           end;
           xi:=r_x;  yi:=r_y;  zi:=round(Z*Z_Factor);
           Quarter_Segment_Ball(xi,yi,zi);
           if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);
         end;
       end;
     end else
     if (r_ya>=r_xa) and (r_ya>=r_za) then
     begin
       if r_ya       =0 then stepx:=r_x-r_xold else stepx:=(r_x-r_xold)/r_ya;
       if r_ya       =0 then stepz:=Z-Zold     else stepz:=(Z-Zold)/r_ya;
       if r_y-r_yold <0 then stepy:=-1         else stepy:=1;
       if r_ya>0 then
       begin
         if Z=Zold then
         begin
           zi:=round(Z*Z_Factor);
           for m:=0 to r_ya do
           begin
             xi:=r_xold+round(stepx*m);
             yi:=r_yold+round(stepy*m);
             {if ToolTab[T].R=0 then Quarter_Segment_Cylinder(xi,yi,zi)
                               else Quarter_Segment_Ball(xi,yi,zi); }
             if ToolTab[T].Form=1 then Quarter_Segment_Cylinder(xi,yi,zi)
                                  else Quarter_Segment_Ball(xi,yi,zi);
             if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);
           end;
         end else
         begin
           for m:=0 to r_ya-1 do
           begin
             xi:=r_xold+round(stepx*m);
             yi:=r_yold+round(stepy*m);
             zi:=round((zold+stepz*m)*Z_Factor);
             {if ToolTab[T].R=0 then Quarter_Segment_Cylinder(xi,yi,zi)
                               else Quarter_Segment_Ball(xi,yi,zi);}
             if ToolTab[T].Form=1 then Quarter_Segment_Cylinder(xi,yi,zi)
                                  else Quarter_Segment_Ball(xi,yi,zi);
             if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);
           end;
           xi:=r_x;  yi:=r_y;  zi:=round(Z*Z_Factor);
           Quarter_Segment_Ball(xi,yi,zi);
           if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);
         end;
       end;
     end else
     if (r_za>=r_xa) and (r_za>=r_ya) then
     begin
       if r_za      =0 then stepx:=r_x-r_xold else stepx:=(r_x-r_xold)/r_za;
       if r_za      =0 then stepy:=r_y-r_yold else stepy:=(r_y-r_yold)/r_za;
       if r_z-r_zold<0 then stepz:=-1         else stepz:=1;
       if r_za>0 then
       begin
         if Z=Zold then
         begin
           zi:=round(Z*Z_Factor);
           for m:=0 to r_za do
           begin
             xi:=r_xold+round(stepx*m);
             yi:=r_yold+round(stepy*m);
             {if ToolTab[T].R=0 then Quarter_Segment_Cylinder(xi,yi,zi)
                               else Quarter_Segment_Ball(xi,yi,zi);}
             if ToolTab[T].Form=1 then Quarter_Segment_Cylinder(xi,yi,zi)
                                  else Quarter_Segment_Ball(xi,yi,zi);
             if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);
           end;
         end else
         begin
           if r_za      =0 then stepx:=r_x-r_xold else stepx:=(r_x-r_xold)/r_za;
           if r_za      =0 then stepy:=r_y-r_yold else stepy:=(r_y-r_yold)/r_za;
           for m:=0 to r_za-1 do
           begin
             xi:=r_xold+round(stepx*m);
             yi:=r_yold+round(stepy*m);
             zi:=round((zold+stepz*m)*Z_Factor);
             {if ToolTab[T].R=0 then Quarter_Segment_Cylinder(xi,yi,zi)
                               else Quarter_Segment_Ball(xi,yi,zi);}
             if ToolTab[T].Form=1 then Quarter_Segment_Cylinder(xi,yi,zi)
                                  else Quarter_Segment_Ball(xi,yi,zi);
             if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);
           end;
           xi:=r_x;  yi:=r_y; zi:=round(Z*Z_Factor);
           Quarter_Segment_Ball(xi,yi,zi);
           if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);
         end;
       end;
     end;
   end;
 end;

//--- Positionierlogik ---------------------------------------------------------
 if GNr=101 then
 begin
   if Z>=Zold then                    // Z>=Zold zuerst Z dann Linear X Y
   begin
     xi:=r_Xold;  yi:=r_Yold;  zi:=round(Z*Z_Factor);
     Quarter_Segment_Ball(xi,yi,zi);
     if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);

     if r_xa>=r_ya then
     begin
       if r_xa      =0 then stepy:=r_y-r_yold else stepy:=(r_y-r_yold)/r_xa;
       if r_x-r_xold<0 then stepx:=-1         else stepx:=1;
       if r_xa>0 then
       begin
         for m:=0 to r_xa do
         begin
           xi:=r_xold+round(stepx*m);
           yi:=r_yold+round(stepy*m);
           {if ToolTab[T].R=0 then Quarter_Segment_Cylinder(xi,yi,zi)
                             else Quarter_Segment_Ball(xi,yi,zi);}
           if ToolTab[T].Form=1 then Quarter_Segment_Cylinder(xi,yi,zi)
                                else Quarter_Segment_Ball(xi,yi,zi);
           if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);
         end;
       end;
     end else
     begin
       if r_ya       =0 then stepx:=r_x-r_xold else stepx:=(r_x-r_xold)/r_ya;
       if r_y-r_yold <0 then stepy:=-1         else stepy:=1;
       if r_ya>0 then
       begin
         for m:=0 to r_ya do
         begin
           xi:=r_xold+round(stepx*m);
           yi:=r_yold+round(stepy*m);
           {if ToolTab[T].R=0 then Quarter_Segment_Cylinder(xi,yi,zi)
                             else Quarter_Segment_Ball(xi,yi,zi);}
           if ToolTab[T].Form=1 then Quarter_Segment_Cylinder(xi,yi,zi)
                                else Quarter_Segment_Ball(xi,yi,zi);
           if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);
         end;
       end;
     end;
   end else                         // Z<Zold zuerst X Y dann Z
   begin
     zi:=round(Zold*Z_Factor);
     if r_xa>=r_ya then
     begin
       if r_xa      =0 then stepy:=r_y-r_yold else stepy:=(r_y-r_yold)/r_xa;
       if r_x-r_xold<0 then stepx:=-1         else stepx:=1;
       if r_xa>0 then
       begin
         for m:=0 to r_xa do
         begin
           xi:=r_xold+round(stepx*m);
           yi:=r_yold+round(stepy*m);
           {if ToolTab[T].R=0 then Quarter_Segment_Cylinder(xi,yi,zi)
                             else Quarter_Segment_Ball(xi,yi,zi);}
           if ToolTab[T].Form=1 then Quarter_Segment_Cylinder(xi,yi,zi)
                                else Quarter_Segment_Ball(xi,yi,zi);
           if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);
         end;
       end;
     end else
     begin
       if r_ya       =0 then stepx:=r_x-r_xold else stepx:=(r_x-r_xold)/r_ya;
       if r_y-r_yold <0 then stepy:=-1         else stepy:=1;
       if r_ya>0 then
       begin
         for m:=0 to r_ya do
         begin
           xi:=r_xold+round(stepx*m);
           yi:=r_yold+round(stepy*m);
           {if ToolTab[T].R=0 then Quarter_Segment_Cylinder(xi,yi,zi)
                             else Quarter_Segment_Ball(xi,yi,zi);}
           if ToolTab[T].Form=1 then Quarter_Segment_Cylinder(xi,yi,zi)
                                else Quarter_Segment_Ball(xi,yi,zi);
           if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);
         end;
       end;
     end;

     xi:=r_X;  yi:=r_Y;  zi:=round(Z*Z_Factor);
     Quarter_Segment_Ball(xi,yi,zi);
     if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);
   end;
 end;

//--- alle Achsen gleichzeitig mit gleichem Vorschub --------------------------
 if(GNr=102)then
 begin
 if (x=xold)and(y=yold)then
 begin
  xi:=round(X);  yi:=round(Y);  zi:=round(Z*Z_Factor);
  if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);
  Quarter_Segment_Ball(xi,yi,zi);
 end else
 begin
  xi:=r_xold;     yi:=r_yold;     zi:=round(zold*Z_Factor);
  {r_x:=round(X);  r_y:=round(Y);  }
  if (r_xa>=r_ya) and (r_xa>=r_za) then mEnd:=r_xa else
  if (r_ya>=r_xa) and (r_ya>=r_za) then mEnd:=r_ya else
  if (r_za>=r_xa) and (r_za>=r_ya) then mEnd:=r_za;
  if r_x<r_xold then stepx:=-1 else stepx:=1;
  if r_y<r_yold then stepy:=-1 else stepy:=1;
  if r_z<r_zold then stepz:=-1 else stepz:=1;
  r_z:=round(Z*Z_Factor);

  if Z=Zold then
  begin
    for m:=0 to mEnd do
     begin
      if stepx= 1 then if xi<r_X then xi:=r_xold+round(stepx*m);
      if stepx=-1 then if xi>r_X then xi:=r_xold+round(stepx*m);

      if stepy= 1 then if yi<r_Y then yi:=r_yold+round(stepy*m);
      if stepy=-1 then if yi>r_Y then yi:=r_yold+round(stepy*m);
      {if ToolTab[T].R=0 then Quarter_Segment_Cylinder(xi,yi,zi)
                        else Quarter_Segment_Ball(xi,yi,zi);}
      if ToolTab[T].Form=1 then Quarter_Segment_Cylinder(xi,yi,zi)
                           else Quarter_Segment_Ball(xi,yi,zi);
      if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);
     end;
  end else
  begin
     for m:=0 to mEnd-1 do
     begin
      if stepx= 1 then if xi<r_X then xi:=r_xold+round(stepx*m);
      if stepx=-1 then if xi>r_X then xi:=r_xold+round(stepx*m);

      if stepy= 1 then if yi<r_Y then yi:=r_yold+round(stepy*m);
      if stepy=-1 then if yi>r_Y then yi:=r_yold+round(stepy*m);

      if stepz= 1 then if zi<r_Z then zi:=round((zold+stepz*m)*Z_Factor);
      if stepz=-1 then if zi>r_Z then zi:=round((zold+stepz*m)*Z_Factor);
      {if ToolTab[T].R=0 then Quarter_Segment_Cylinder(xi,yi,zi)
                        else Quarter_Segment_Ball    (xi,yi,zi);}
      if ToolTab[T].Form=1 then Quarter_Segment_Cylinder(xi,yi,zi)
                           else Quarter_Segment_Ball(xi,yi,zi);
      if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);
     end;
     xi:=r_X;
     yi:=r_Y;
     zi:=round(Z*Z_Factor);
     Quarter_Segment_Ball(xi,yi,zi);
     if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);
    end;
   end;

  end;
{//--- Achsen nacheinander , grter Abstand zuerst -----------------------------
 if(GNr=103)then
 begin
   mEnd:=0;
   xi:=r_xold;     yi:=r_yold;     zi:=r_zold;
   if r_x<r_xold then stepx:=-1 else stepx:=1;
   if r_y<r_yold then stepy:=-1 else stepy:=1;
   if r_z<r_zold then stepz:=-1 else stepz:=1;
   repeat
     if(xa>=ya)and(xa>=za)then
     begin
       ziTemp:=zi*Z_Factor;
       for m:=0 to r_xa do
       begin
         xi:=r_xold+round(m*stepx);
         //if ToolTab[T].R=0 then Quarter_Segment_Cylinder(xi,yi,ziTemp)
         //                  else Quarter_Segment_Ball    (xi,yi,ziTemp);
         if ToolTab[T].Form=1 then Quarter_Segment_Cylinder(xi,yi,zi)
                              else Quarter_Segment_Ball(xi,yi,zi);
         if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,ziTemp);
       end;
       xa:=0;  xi:=r_x;
     end;
     if(ya>=xa)and(ya>=za)then
     begin
      ziTemp:=zi*Z_Factor;
      for m:=0 to r_ya do
       begin
         yi:=r_yold+round(m*stepy);
         //if ToolTab[T].R=0 then Quarter_Segment_Cylinder(xi,yi,ziTemp)
         //                  else Quarter_Segment_Ball    (xi,yi,ziTemp);
         if ToolTab[T].Form=1 then Quarter_Segment_Cylinder(xi,yi,zi)
                              else Quarter_Segment_Ball(xi,yi,zi);
         if View_Tool_Contour=false then F_2D.MPixel_G  (xi,yi,ziTemp);
       end;
       ya:=0;
       yi:=r_y;
       //if ToolTab[T].R=0 then Quarter_Segment_Cylinder(xi,yi,ziTemp)
       //                  else Quarter_Segment_Ball    (xi,yi,ziTemp);
       if ToolTab[T].Form=1 then Quarter_Segment_Cylinder(xi,yi,zi)
                            else Quarter_Segment_Ball(xi,yi,zi);
       if View_Tool_Contour=false then F_2D.MPixel_G  (xi,yi,ziTemp);
     end;
     if(za>=xa)and(za>=ya)then
     begin
       za:=0;
       zi:=r_z;
       ziTemp:=zi*Z_Factor;
                                       Quarter_Segment_Ball(xi,yi,ziTemp);
       if View_Tool_Contour=false then F_2D.MPixel_G       (xi,yi,ziTemp);
     end;
     inc(mEnd);
     if mEnd>1000000 then F_Infos.RichEdit1.lines.add('ERROR Loop out, Proc. Linear');
  until ((xa=0)and(ya=0)and(za=0))or (mEnd>1000001);
 end;}
end;
// ------------------------- Start- und Endpunkt fr Kreisabschnitt ermitteln ----------------------------
FUNCTION Circle_Angle_Calculate(xk,yk:real):real;
Begin
if(xk> 0)and(yk<=0) then if yk=0 then
   Circle_Angle_Calculate:=6.2831853 else Circle_Angle_Calculate:=4.712389 +arctan( xk/-yk);
if(xk<=0)and(yk< 0) then if xk=0 then
   Circle_Angle_Calculate:=4.712389  else Circle_Angle_Calculate:=4.712389 -arctan( xk/ yk);
if(xk< 0)and(yk>=0) then if yk=0 then
   Circle_Angle_Calculate:=3.1415927 else Circle_Angle_Calculate:=1.5707963+arctan(-xk/ yk);
if(xk>=0)and(yk> 0) then if xk=0 then
   Circle_Angle_Calculate:=1.5707963 else Circle_Angle_Calculate:=1.5707963-arctan( xk/ yk);
end;
// ------------------------- CircleR_Move CircleL_Move PROCEDUREN ----------------------------------------
PROCEDURE CircleR_Move;
var w0,w1,wa,wi,alpha,x0,y0,x1,y1,Radius,stepz:real;
    xi,yi,zi,zaehler,a:longint;
begin
x0:=xold-i;y0:=yold-j;x1:=x-i;y1:=y-j;
radius:=sqrt(sqr(x0)+sqr(y0));

Tool_GT_Check(round(Z*Z_Factor));
if radius>1 then
  begin
  w0:=Circle_Angle_Calculate(x0,y0);
  w1:=Circle_Angle_Calculate(x1,y1);
  if w1=w0 then wa:=6.2831853 else
  if w1>w0 then wa:=6.2831853-(w1-w0) else wa:=w0-w1;
  wi:=arctan(1/sqrt(sqr(radius)+1));
  zaehler:=trunc(wa/wi);
  if Zaehler>0then wi:=wa/Zaehler else wi:=wa;
  stepz:=(z-zold)/(wa/wi);
  if Zaehler>0then
  begin
    if z=zold then
    begin
      for a:=0 to Zaehler do
      begin
        alpha:=w0-(wi*a);
        xi:=round(cos(alpha)*radius+i);
        yi:=round(sin(alpha)*radius+j);
        zi:=round((zold+(stepz*a))*Z_Factor);
        {if ToolTab[T].R=0then Quarter_Segment_Cylinder(xi,yi,zi)
                             else Quarter_Segment_Ball(xi,yi,zi);}
        if ToolTab[T].Form=1 then Quarter_Segment_Cylinder(xi,yi,zi)
                             else Quarter_Segment_Ball(xi,yi,zi);
        if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);
      end;
    end else
    begin
      for a:=0 to Zaehler do
        begin
          alpha:=w0-(wi*a);
          xi:=round(cos(alpha)*radius+i);
          yi:=round(sin(alpha)*radius+j);
          zi:=round((zold+(stepz*a))*Z_Factor);
          Quarter_Segment_Ball(xi,yi,zi);
          if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);
        end;
    end;
  end;
 end;
end;

PROCEDURE CircleL_Move;
var w0,w1,wa,wi,alpha,x0,y0,x1,y1,Radius,stepz:real;
    xi,yi,zi,zaehler,a:longint;
begin
x0:=xold-i;y0:=yold-j;x1:=x-i;y1:=y-j;
radius:=sqrt(sqr(x0)+sqr(y0));
Tool_GT_Check(round(Z*Z_Factor));

if radius>1 then
begin
  w0:=Circle_Angle_Calculate(x0,y0);
  w1:=Circle_Angle_Calculate(x1,y1);
  if w1=w0 then wa:=6.2831853 else
  if w1>w0 then wa:=w1-w0 else wa:=6.2831853-(w0-w1);
  wi:=arctan(1/sqrt(sqr(radius)-1));
  zaehler:=trunc(wa/wi);
  if Zaehler>0then wi:=wa/Zaehler else wi:=wa;
  stepz:=(z-zold)/(wa/wi);
  if Zaehler>0then
  begin
    if z=zold then
    begin
    for a:=0 to Zaehler do
      begin
        alpha:=w0+(wi*a);
        xi:=round(cos(alpha)*radius+i);
        yi:=round(sin(alpha)*radius+j);
        zi:=round((zold+(stepz*a))*Z_Factor);
        {if ToolTab[T].R=0then Quarter_Segment_Cylinder(xi,yi,zi)
                             else Quarter_Segment_Ball(xi,yi,zi);}
        if ToolTab[T].Form=1 then Quarter_Segment_Cylinder(xi,yi,zi)
                             else Quarter_Segment_Ball(xi,yi,zi);
        if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);
      end;
    end else
    begin
    for a:=0 to Zaehler do
      begin
        alpha:=w0+(wi*a);
        xi:=round(cos(alpha)*radius+i);
        yi:=round(sin(alpha)*radius+j);
        zi:=round((zold+(stepz*a))*Z_Factor);
        Quarter_Segment_Ball(xi,yi,zi);
        if View_Tool_Contour=false then F_2D.MPixel_G(xi,yi,zi);
      end;
    end;
  end;
end;
end;


end.
