unit U_ReadToolFile;

interface

type Tool_Rec = record
                use    :boolean;
                Form   :integer;
                Typ    :integer;
                D      :real;
                R      :real;
                Grad   :real;
                GT     :real;
                GSL    :real;
                GTist  :real;
                GSList :real;
                F      :integer;  // zum Einlesen
                Fmax   :integer;  // zum berprfen bei G*
                Fmin   :integer;  //         "
                S      :integer;  // zum Einlesen
                Smax   :integer;  // zum berprfen bei G*
                Smin   :integer;  //         "
                FSdef  :boolean;  // wenn Voreinstellung F und S
                G0max  :real;
                Info   :string;
                end;
var ToolTab     :array[0..100]  of Tool_Rec;
    sErrorResult:string;

Function Read_Tool_File(sFileName:string):boolean;
Function Tool_Typ(a:cardinal):string;
Function Tool_Form(a:cardinal):string;

implementation

uses U_2DFenster, U_AdressValue, Sysutils;

Function Tool_Form(a:cardinal):string;
begin
 case a of
   0 :Result:='nicht definiert';
   1 :Result:='Zylinder';
   2 :Result:='Kugel';
   3 :Result:='Radius';
   4 :Result:='Kegel';
 else Result:='ERROR Func. Tool_Form';
 end;
end;

Function Tool_Typ(a:cardinal):string;
begin
 case a of
   0 :Result:='';
   1 :Result:='Plankopf';
   2 :Result:='Zylinderfrser';
   3 :Result:='Kugelfrser';
   4 :Result:='Radienfrser auen';
   5 :Result:='Radienfrser innen';
   10:Result:='Stichel';
   11:Result:='Stichel Kugel';
   12:Result:='Stichel Auenradius';
   13:Result:='Stichel Innenradius';
   20:Result:='Anbohrer';
   21:Result:='Zentrierbohrer';
   22:Result:='Bohrer';
   23:Result:='Reibahle';
   24:Result:='Stirnreibahle';
 else Result:='ERROR Func. Tool_Typ';
 end;
end;

Function Read_Tool_File(sFileName:string):boolean;
var a, Line_PosTemp, wo:cardinal;
    T_Temp, Form_Temp, Typ_Temp:integer;
    D_Temp, R_Temp, Grad_Temp, GT_Temp, GSL_Temp:real;
    sValueTemp:string;
begin
 for a:=1 to 100 do
 begin ToolTab[a].use:=false;
       ToolTab[a].D:=0;
       ToolTab[a].R:=0;
       ToolTab[a].Grad:=0;
       ToolTab[a].Form:=0;
       ToolTab[a].Typ:=0;
       ToolTab[a].GT  :=0;  ToolTab[a].GTist :=0;
       ToolTab[a].GSL :=0;  ToolTab[a].GSList:=0;
       ToolTab[a].F   :=0;  ToolTab[a].S     :=0;
       ToolTab[a].Fmax:=0;  ToolTab[a].Smax  :=0;
       ToolTab[a].Fmin:=-1;  ToolTab[a].Smin  :=-1;
       ToolTab[a].FSdef:=false;ToolTab[a].Info:='';
 end;
 sErrorResult:='';
 AssignFile(F_FRA,sFileName);{$I-} Reset(F_FRA); {$I+}
 {$I-} Reset(F_FRA);{$I+}
 if IOResult =0 then
 begin
   while not eof(F_FRA) do
   begin
     readln(F_FRA,Line_s);
     while pos(#9,Line_s)>0 do Line_s[pos(#9,Line_s)]:=' ';
     Line_End:=length(Line_s);
     T_Temp:=0; D_Temp:=0; R_Temp:=0; Grad_Temp:=0; GT_Temp:=0; GSL_Temp:=0;
     Form_Temp:=0; Typ_Temp:=0;
     Line_pos:=1;
     while Find_Tool_Adress do
     begin
//-------------------------- Adresse und Wert oder Code ermitteln ----------------------------------------
       if sAdress='T' then
       begin
         if Find_Integer_Value then
         begin
           if iValue>0 then
           if iValue<101 then
           begin
             if T_Temp>0
             then sErrorResult:=sErrorResult+
               'Fehler:T bereits belegt in Zeile '''+Line_s+''''+#10
             else T_Temp:=iValue;
           end else
             sErrorResult:=sErrorResult+'Fehler:T '+IntToStr(iValue)+
             ' fehlerhaft in Zeile '''+Line_s+''''+#10;
         end else
         if T_Temp=0 then
           sErrorResult:=sErrorResult+
           'Syntaxfehler:Adresse T ohne Wert in Zeile '''+Line_s+''''+#10;
       end;
       if sAdress='D' then
       begin
         if Find_Float_Value then
         begin
           if(fValue>=0)and(fValue<=100)then
           begin
             if D_Temp>0 then
             sErrorResult:=sErrorResult+
             'Fehler:D bereits belegt in Zeile '''+Line_s+''''+#10
             else
             D_Temp:=fValue /2;
           end else
             sErrorResult:=sErrorResult+'Fehler:D '+
             FloatToStrf(fValue,ffFixed,15,2)+' fehlerhaft in Zeile '''+Line_s+''''+#10;
         end else
           if D_Temp=0 then
           sErrorResult:=sErrorResult+
           'Syntaxfehler:Adresse D ohne Wert in Zeile '''+Line_s+''''+#10;
       end;
       if sAdress='R' then
       begin
         if Find_Float_Value then
         begin
           if(fValue>=0)and(fValue<=50) then
           begin
             if R_Temp>0 then
             sErrorResult:=sErrorResult+
             'Fehler:R bereits belegt in Zeile '''+Line_s+''''+#10
             else
             R_Temp:=fValue;
           end else
             sErrorResult:=sErrorResult+'Fehler:R '+
             FloatToStrf(fValue,ffFixed,15,2)+' fehlerhaft in Zeile '''+
             Line_s+''''+#10;
         end else
           if R_Temp=0 then
           sErrorResult:=sErrorResult+
           'Syntaxfehler:Adresse R ohne Wert in Zeile '''+Line_s+''''+#10;
       end;
       if sAdress='GT' then
       begin
         if Find_Float_Value then
         begin
           if(fValue>=0)and(fValue<=9999)then
           begin
             if GT_Temp>0
             then sErrorResult:=sErrorResult+
                'Fehler:GT bereits belegt in Zeile '''+Line_s+''''+#10
             else
             begin
               GT_Temp:=fValue;
               if fValue>500
               then sErrorResult:=sErrorResult+'Hinweis:Werkzeulnge '+
                    FloatToStrf(fValue,ffFixed,15,2)+'??? in Zeile '''+Line_s+''''+#10;
               if Find_Next_Char('/')then
               begin
                 if Find_Float_Value then
                 begin
                   if(fValue>=0)and(fValue<=9999)then
                   begin
                     GSL_Temp:=fValue;
                     if fValue>500
                     then sErrorResult:=sErrorResult+'Hinweis:Frser Schneidenlnge '+
                          FloatToStrf(fValue,ffFixed,15,2)+'??? in Zeile '''+Line_s+''''+#10;
                   end else
                     sErrorResult:=sErrorResult+'Fehler:GSL '+
                     FloatToStrf(fValue,ffFixed,15,2)+' fehlerhaft in Zeile '''+
                     Line_s+''''+#10;
                 end else
                   sErrorResult:=sErrorResult+
                   'Syntaxfehler:Adresse GSL ohne Wert in Zeile '''+Line_s+''''+#10;
               end;
             end;
           end else
             sErrorResult:=sErrorResult+'Fehler:GT '+
             FloatToStrf(fValue,ffFixed,15,2)+' fehlerhaft in Zeile '''+
             Line_s+''''+#10;
         end else
         if GT_Temp=0 then sErrorResult:=sErrorResult+
           'Syntaxfehler:Adresse GT ohne Wert in Zeile '''+Line_s+''''+#10;
       end;
       //***Ausnahme, Wert vor Adresse***
       if UpperCase(sAdress)='GRAD' then
       begin
         Line_posTemp:=Line_Pos-5;
         sValueTemp:='';
         if Line_PosTemp>0 then
         begin
           while((Line_s[Line_posTemp]=' ')or(Line_s[Line_posTemp]=#9))and
                 (Line_pos>0)do dec(Line_posTemp);
           while(Line_s[Line_posTemp]>='0')and(Line_s[Line_posTemp]<='9')do
           begin
             sValueTemp:=Line_s[Line_posTemp]+sValueTemp;
           if Line_posTemp>0 then dec(Line_posTemp) else break;
           end;
           if sValueTemp<>''then
           begin
             if DecimalSeparator=','then
             begin wo:=pos('.',sValueTemp);
               if wo>0then
               begin delete(sValueTemp,wo,1);insert(',',sValueTemp,wo);end;
             end;
             Grad_Temp:=StrToFloat(sValueTemp);
           end else sErrorResult:=sErrorResult+
             'Syntaxfehler:Adresse Grad ohne Wert in Zeile '''+Line_s+''''+#10;
         end else
           sErrorResult:=sErrorResult+
           'Syntaxfehler:Adresse Grad ohne Wert in Zeile '''+Line_s+''''+#10;
       end;
       if sAdress='-'then Break;

       if UpperCase(sAdress)='PLAN'           then Typ_Temp:=1  else
       if UpperCase(sAdress)='PLANKOPF'       then Typ_Temp:=1  else
       if UpperCase(sAdress)='STICHEL'        then Typ_Temp:=10 else
       if UpperCase(sAdress)='ANBOHRER'       then Typ_Temp:=20 else
       if UpperCase(sAdress)='ZENTRIERBOHRER' then Typ_Temp:=21 else
       if UpperCase(sAdress)='BOHRER'         then Typ_Temp:=22 else
       if UpperCase(sAdress)='AHLE'           then Typ_Temp:=23 else
       if UpperCase(sAdress)='REIBAHLE'       then Typ_Temp:=23 else
       if UpperCase(sAdress)='STIRNREIBAHLE'  then Typ_Temp:=24 ;



     end;// Ende von "while Find_Tool_Adress do"

     if Typ_Temp=20 then
     begin
       if D_Temp=0 then
       begin
         sErrorResult:=sErrorResult+'Hinweis:T'+IntToStr(T_Temp)+
         ' Anbohrer Durchmesserangabe = 0 in Zeile '''+Line_s+''', wird auf D6 gesetzt'+#10;
         D_Temp:=6;
       end;
       if Grad_Temp=0 then Grad_Temp:=120;
     end else
     if Typ_Temp=22  then
     begin
       if Grad_Temp=0 then Grad_Temp:=120;
     end else
     if Typ_Temp=10 then
     begin
       if D_Temp=0 then
       begin
         sErrorResult:=sErrorResult+'Hinweis:T'+IntToStr(T_Temp)+
         ' Stichel Durchmesserangabe = 0 in Zeile '''+Line_s+''', wird auf D6 gesetzt'+#10;
         D_Temp:=6;
       end;
     end;

     if(T_Temp>0)and(T_Temp<101)then
     begin
       if D_Temp=0 then
          sErrorResult:=sErrorResult+'Hinweis:T'+IntToStr(T_Temp)+
          ' Werkzeug Durchmesserangabe = 0  in Zeile '''+Line_s+''''+#10
                   else
       if D_Temp<0.25 then
          sErrorResult:=sErrorResult+'Hinweis:T'+IntToStr(T_Temp)+
          ' Werkzeug Durchmesserangabe < 0.5  in Zeile '''+Line_s+''''+#10;
       if R_Temp>D_Temp then
       begin
         R_Temp:=D_Temp/2;
         sErrorResult:=sErrorResult+'Fehler:T'+IntToStr(T_Temp)+
         ' Werkzeug-Eckradius grer Durchmesser, wird auf'+
         ' Kugel eingestellt in Zeile '''+Line_s+''''+#10;
       end;
       if(Grad_Temp>0)then
       if (round(R_Temp*100)>0)and(Grad_Temp<180) then
       begin
         sErrorResult:=sErrorResult+'Hinweis:T'+IntToStr(T_Temp)+
          ' Werkzeug Radius wird ignoriert wegen Gradangabe in Zeile '''+
          Line_s+''''+#10;
          R_Temp:=0;
       end;
       if(Grad_Temp>0)then
       if(Grad_Temp<10)or(Grad_Temp>180)then
       begin
         sErrorResult:=sErrorResult+'Fehler:Werkzeug Gradzahl'+
         FloatToStrf(Grad_Temp,ffFixed,15,2)+' nicht im Bereich 10..180'+
         ', wird auf 180(Zylinder) gesetzt in Zeile '''+Line_s+''''+#10;
         Form_Temp:=1;
       end;

       if R_Temp=0 then
       begin
         if Grad_Temp=0 then Form_Temp:=1
                        else Form_Temp:=4;
       end else
       if R_Temp=D_Temp then               Form_Temp:=2 else
       if(R_Temp>0)and(R_Temp<D_Temp) then Form_Temp:=3;// else

       ToolTab[T_Temp].D   :=D_Temp;
       ToolTab[T_Temp].R   :=R_Temp;
       ToolTab[T_Temp].Grad:=Grad_Temp;
       ToolTab[T_Temp].GT  :=GT_Temp;
       ToolTab[T_Temp].GSL :=GSL_Temp;
       ToolTab[T_Temp].Form:=Form_Temp;
       ToolTab[T_Temp].Typ :=Typ_Temp;;
     end;//if(T_Temp>0)and(T_Temp<101)then
//--------------------------------------------------------------------------------------
   end;// Ende von "while not eof(F_FRA) do"
   CloseFile(F_FRA);
   Result:=true;
 end else Result:=false;//Ende von if IOResult =0 then
end;

end.
