unit U_Material;

interface

uses OpenGL, U_OpenGL;
const
 White     = 0;
 Red       = 1;
 Green     = 2;
 Blue      = 3;
 Yellow    = 4;
 Stahl     = 5;
 Aluminium = 6;
 Copper    = 7;
 Bronze    = 8;
 Chrome    = 9;
 Gold      = 10;
 Silver    = 11;

{Wei  }WhiAmb : Array[1..4] of GLFloat = (0.5,0.5,0.5,1);
        WhiDif : Array[1..4] of GLFloat = (0.5,0.5,0.5,1);
        WhiSpe : Array[1..4] of GLFloat = (0.5,0.5,0.5,1);
        WhiShi = 90;
{Rot   }RedAmb : Array[1..4] of GLFloat = (0.2,0,0,1);
        RedDif : Array[1..4] of GLFloat = (0.5,0,0,1);
        RedSpe : Array[1..4] of GLFloat = (0.6,0,0,1);
        RedShi = 90;
{Grn  }GreAmb : Array[1..4] of GLFloat = (0,0.2,0,1);
        GreDif : Array[1..4] of GLFloat = (0,0.5,0,1);
        GreSpe : Array[1..4] of GLFloat = (0,0.6,0,1);
        GreShi = 90;
{Blau  }BluAmb : Array[1..4] of GLFloat = (0,0,0.2,1);
        BluDif : Array[1..4] of GLFloat = (0,0,0.5,1);
        BluSpe : Array[1..4] of GLFloat = (0,0,0.6,1);
        BluShi = 90;
{Gelb}  YelAmb : Array[1..4] of GLFloat = (0.2,0.2,0,1);
        YelDif : Array[1..4] of GLFloat = (0.5,0.5,0,1);
        YelSpe : Array[1..4] of GLFloat = (0.6,0.6,0,1);
        YelShi = 90;
{Eisen }IroAmb  : Array[1..4] of GLFloat = (0.1     , 0.1     , 0.1      , 1);
        IroDif  : Array[1..4] of GLFloat = (0.4     , 0.4     , 0.4      , 1);
        IroSpe  : Array[1..4] of GLFloat = (0.4     , 0.4     , 0.4      , 1);
        IroShi = 89.6;
{Alu}   AluAmb  : Array[1..4] of GLFloat = (0.2   , 0.2     , 0.2     , 1);
        AluDif  : Array[1..4] of GLFloat = (0.5   , 0.5     , 0.5     , 1);
        AluSpe  : Array[1..4] of GLFloat = (0.4   , 0.4     , 0.4     , 1);
        AluShi = 89.6;
{Kupfer}PCopAmb : Array[1..4] of GLFloat = (0.2295  , 0.08825 , 0.0275   , 1);
        PCopDif : Array[1..4] of GLFloat = (0.5508  , 0.2118  , 0.066    , 1);
        PCopSpe : Array[1..4] of GLFloat = (0.580594, 0.223257, 0.0695701, 1);
        PCopShi = 51.2;
{Bronze}PBroAmb : Array[1..4] of GLFloat = (0.25    , 0.148   , 0.06475  , 1);
        PBroDif : Array[1..4] of GLFloat = (0.4     , 0.2368  , 0.1036   , 1);
        PBroSpe : Array[1..4] of GLFloat = (0.774597, 0.458561, 0.200621 , 1);
        PBroShi = 76.8;
{Chrome}ChrAmb  : Array[1..4] of GLFloat = (0.25    , 0.25    , 0.25     , 1);
        ChrDif  : Array[1..4] of GLFloat = (0.4     , 0.4     , 0.4      , 1);
        ChrSpe  : Array[1..4] of GLFloat = (0.774597, 0.774597, 0.774597 , 1);
        ChrShi = 76.8;
{Gold}  PGolAmb : Array[1..4] of GLFloat = (0.24725 , 0.2245  , 0.0645   , 1);
        PGolDif : Array[1..4] of GLFloat = (0.34615 , 0.3143  , 0.0903   , 1);
        PGolSpe : Array[1..4] of GLFloat = (0.797357, 0.723991, 0.208006 , 1);
        PGolShi = 83.2;
{Silber}PSilAmb : Array[1..4] of GLFloat = (0.23125 , 0.23125 , 0.23125  , 1);
        PSilDif : Array[1..4] of GLFloat = (0.2775  , 0.2775  , 0.2775   , 1);
        PSilSpe : Array[1..4] of GLFloat = (0.77391 , 0.77391 , 0.77391  , 1);
        PSilShi = 89.6;

 procedure Material_Init_Const(WhatMaterial : integer);

implementation

procedure Material_Init_Const(WhatMaterial : integer);
const glfMatrialEmission  : array[0..3] of GLfloat =(0,0,0,1);
var   i:integer;
begin
   for i:=1 to 4 do
   begin
    case whatMaterial of
    0:begin  MatrialAmbient[i] :=WhiAmb[i];
             MatrialDiffuse[i] :=WhiDif[i];
             MatrialSpecular[i]:=WhiSPE[i];
             MatrialShine   :=WhiShi;
      end;
    1:begin  MatrialAmbient[i] :=RedAmb[i];
             MatrialDiffuse[i] :=RedDif[i];
             MatrialSpecular[i]:=RedSPE[i];
             MatrialShine   :=RedShi;
      end;
    2:begin  MatrialAmbient[i] :=GreAmb[i];
             MatrialDiffuse[i] :=GreDif[i];
             MatrialSpecular[i]:=GreSPE[i];
             MatrialShine   :=GreShi;
      end;
    3:begin  MatrialAmbient[i] :=BluAmb[i];
             MatrialDiffuse[i] :=BluDif[i];
             MatrialSpecular[i]:=BluSPE[i];
             MatrialShine   :=BluShi;
      end;
    4:begin  MatrialAmbient[i] :=YelAmb[i];
             MatrialDiffuse[i] :=YelDif[i];
             MatrialSpecular[i]:=YelSPE[i];
             MatrialShine   :=YelShi;
      end;
    5:begin  MatrialAmbient[i] :=IroAmb[i];
             MatrialDiffuse[i] :=IroDif[i];
             MatrialSpecular[i]:=IroSPE[i];
             MatrialShine   :=IroShi;
      end;
    6:begin  MatrialAmbient[i] :=AluAmb[i];
             MatrialDiffuse[i] :=AluDif[i];
             MatrialSpecular[i]:=AluSPE[i];
             MatrialShine   :=AluShi;
      end;
    7:begin  MatrialAmbient[i] :=PCopAmb[i];
             MatrialDiffuse[i] :=PCopDif[i];
             MatrialSpecular[i]:=PCopSPE[i];
             MatrialShine   :=PCopShi;
      end;
    8:begin  MatrialAmbient[i] :=PBroAmb[i];
             MatrialDiffuse[i] :=PBroDif[i];
             MatrialSpecular[i]:=PBroSPE[i];
             MatrialShine   :=PBroShi;
      end;
    9:begin  MatrialAmbient[i] :=ChrAmb[i];
             MatrialDiffuse[i] :=ChrDif[i];
             MatrialSpecular[i]:=ChrSPE[i];
             MatrialShine   :=ChrShi;
      end;
   10:begin  MatrialAmbient[i] :=PGolAmb[i];
             MatrialDiffuse[i] :=PGolDif[i];
             MatrialSpecular[i]:=PGolSPE[i];
             MatrialShine   :=PGolShi;
      end;
   11:begin  MatrialAmbient[i] :=PSilAmb[i];
             MatrialDiffuse[i] :=PSilDif[i];
             MatrialSpecular[i]:=PSilSPE[i];
             MatrialShine   :=PSilShi;
      end;
   end;
 end;
end;
end.

