unit U_OpenGLListe;

interface

type Point=record
     x:real;
     y:real;
     z:real;
     end;
var  P0,P1,P2,P3:Point;
     Vw,Vu,Vv:array [0..2]of real{glFloat};
     PolyZahl:integer;
     Points_Round:boolean;

 Procedure Normal_Vector;                        //Normalenvektor berechnen und normalisieren
 Procedure Point_in_List(P0:Point);              //Punkt in Displayliste schreiben
 Procedure Quad_in_List(P0,P1,P2,P3:Point);      //Viereck in Displayliste
 Procedure TriangleVar1_in_List(P0,P1,P2,P3:Point);//2 Dreiecke,Variante 1 in Displayliste
 Procedure TriangleVar2_in_List(P0,P1,P2,P3:Point);//2 Dreiecke,Variante 2 in Displayliste

 Procedure List_Fill_Call;                       //alle Listen aufrufen zum Fllen
 Procedure Triangle_List_Fill;                   //Dreieckliste
 Procedure Quad_List_Fill;                       //Viereckliste
 Procedure Point_List_Fill;                      //Punktliste
{ Procedure Material_List_Fill;                   //Rohmaterial}

 Function  OccupiedBit_Check(y,x:integer):integer;
 Procedure OccupiedBit_Set(y,x:integer);
implementation

uses U_OpenGL, opengl, U_2DFenster, U_Infos, U_ZeileLesen;
{Bitoperationen    1100     1100      1100               
               and 1010  or 1010  xor 1010
                 = 1000   = 1110    = 0110  }
Function OccupiedBit_Check(y,x:integer):integer;
var XSeg,XBit,iBit:Cardinal;
begin
 XSeg:=(x div 32);  XBit:=x-(XSeg*32);
 iBit:=1;
 iBit:=iBit shl(XBit);
 iBit:=iBit and OccupiedBit_arr[y,XSeg];
 iBit:=iBit shr(XBit);
 OccupiedBit_Check:=iBit;
end;

Procedure OccupiedBit_Set(y,x:integer);
var XSeg,XBit,iBit:Cardinal;
begin
 XSeg:=(x div 32);  XBit:=x-(XSeg*32);
 iBit:=1;
 iBit:=iBit shl(XBit);
 iBit:=iBit and OccupiedBit_arr[y,XSeg];
 iBit:=iBit shr(XBit);
 if iBit=0 then
 begin  iBit:=1;
        iBit:=iBit shl(XBit);
        OccupiedBit_arr[y,XSeg]:=OccupiedBit_arr[y,XSeg] xor iBit;
 end;
end;
//-------------------------- Normalenvektor --------------------------------------------------------------
Procedure Normal_Vector;
var VLaenge,rFactor:real;
    temp:real;
begin
 Vw[0]:=Vu[1]*Vv[2]-Vu[2]*Vv[1];
 Vw[1]:=Vu[2]*Vv[0]-Vu[0]*Vv[2];
 Vw[2]:=Vu[0]*Vv[1]-Vu[1]*Vv[0];
 temp:=sqr(Vw[0])+sqr(Vw[1])+sqr(Vw[2]);
 VLaenge:=sqrt(temp);
 if Vlaenge<>1 then
 begin
  rFactor:=1/VLaenge;                            //Normalenvektor auf Lnge 1 bringen
  Vw[0]:=rFactor * Vw[0];
  Vw[1]:=rFactor * Vw[1];
  Vw[2]:=rFactor * Vw[2];
 end;
end;
//-------------------------- Punkt Dreiecke Viereck in Liste ---------------------------------------------
Procedure Point_in_List(P0:Point);
Begin glVertex3f(P0.X ,P0.Y ,P0.Z);
end;

Procedure TriangleVar1_in_List(P0,P1,P2,P3:Point);
Begin {3 --- 2
       | \   |
       |   \ |
      0 --- 1}
 Vu[0]:=P1.X-P0.X; Vu[1]:=0;         Vu[2]:=P1.Z-P0.Z;
 Vv[0]:=0;         Vv[1]:=P3.Y-P0.Y; Vv[2]:=P3.Z-P0.Z;
 Normal_Vector;
 glNormal3f(Vw[0],Vw[1],Vw[2]);                  //Vektor fr Belechtungsberechnung ein Polygon
   glVertex3f( P0.X ,P0.Y, P0.Z);
   glVertex3f( P1.X ,P1.Y, P1.Z);
   glVertex3f( P3.X ,P3.Y, P3.Z);

 Vu[0]:=P2.X-P3.X; Vu[1]:=0;         Vu[2]:=P2.Z-P3.Z;
 Vv[0]:=0;         Vv[1]:=P2.Y-P1.Y; Vv[2]:=P2.Z-P1.Z;
 Normal_Vector;
 glNormal3f(Vw[0],Vw[1],Vw[2]);                  //Vektor fr Belechtungsberechnung ein Polygon
   glVertex3f(P2.X ,P2.Y, P2.Z);
   glVertex3f(P3.X ,P3.Y, P3.Z);
   glVertex3f(P1.X ,P1.Y, P1.Z);
 inc(PolyZahl);inc(PolyZahl);
end;

Procedure TriangleVar2_in_List(P0,P1,P2,P3:Point);
Begin{3 --- 2
      |   / |
      | /   |
      0 --- 1}
 Vu[0]:=P2.X-P3.X; Vu[1]:=0;         Vu[2]:=P2.Z-P3.Z;
 Vv[0]:=0;         Vv[1]:=P3.Y-P0.Y; Vv[2]:=P3.Z-P0.Z;
 Normal_Vector;
 glNormal3f(Vw[0],Vw[1],Vw[2]);                  //Vektor fr Belechtungsberechnung ein Polygon
  glVertex3f( P3.X ,P3.Y, P3.Z);
  glVertex3f( P0.X ,P0.Y, P0.Z);
  glVertex3f( P2.X ,P2.Y, P2.Z);

 Vu[0]:=P1.X-P0.X; Vu[1]:=0;         Vu[2]:=P1.Z-P0.Z;
 Vv[0]:=0;         Vv[1]:=P2.Y-P1.Y; Vv[2]:=P2.Z-P1.Z;
 Normal_Vector;
 glNormal3f(Vw[0],Vw[1],Vw[2]);                  //Vektor fr Belechtungsberechnung ein Polygon
  glVertex3f(P1.X ,P1.Y, P1.Z);
  glVertex3f(P2.X ,P2.Y, P2.Z);
  glVertex3f(P0.X ,P0.Y, P0.Z);
 inc(PolyZahl);inc(PolyZahl);
end;

Procedure Quad_in_List(P0,P1,P2,P3:Point);
Begin
 Vu[0]:=P1.X-P0.X; Vu[1]:=0;         Vu[2]:=P1.Z-P0.Z;
 Vv[0]:=0;         Vv[1]:=P3.Y-P0.Y; Vv[2]:=P3.Z-P0.Z;
 Normal_Vector;
 glNormal3f(Vw[0],Vw[1],Vw[2]);                  //Vektor fr Belechtungsberechnung ein Polygon
  glVertex3f(P0.X ,P0.Y , P0.Z);
  glVertex3f(P1.X ,P1.Y , P1.Z);
  glVertex3f(P2.X ,P2.Y , P2.Z);
  glVertex3f(P3.X ,P3.Y , P3.Z);
 inc(PolyZahl);
end;
//-------------------------------- Triangleliste ---------------------------------------------------------
Procedure Triangle_List_Fill;
var xf,yf,V1,V2,V3,Za1,Za2:integer;
    Factor:integer;
begin
 if DebugP then F_Infos.ListBox1.Items.add('OpenGL Triangle_List_Fill');
 if Points_round then Factor:=Z_Factor div 10
                 else Factor:=Z_Factor div 100;
 for yf:=GL_Y0 to GL_Y1-1 do
 begin
  for xf:=GL_X0 to GL_X1-1 do
  begin
   V1:=round(Kontur_arr[yf+1,xf  ]/Factor)-round(Kontur_arr[yf,xf  ]/Factor);
   V2:=round(Kontur_arr[yf  ,xf+1]/factor)-round(Kontur_arr[yf,xf  ]/Factor);
   V3:=round(Kontur_arr[yf+1,xf+1]/Factor)-round(Kontur_arr[yf,xf+1]/Factor);
   if V1<>V3 then
   begin
    P0.X:=xf;      P0.Y:=yf;
    if Points_round then P0.Z:=round(Kontur_arr[yf   ,xf  ] / Factor)/10
                             else P0.Z:=round(Kontur_arr[yf   ,xf  ] / Factor)/100;
    P1.X:=xf+1;    P1.Y:=yf;
    if Points_round then P1.Z:=round(Kontur_arr[yf   ,xf+1] / Factor)/10
                             else P1.Z:=round(Kontur_arr[yf   ,xf+1] / Factor)/100;
    P2.X:=xf+1;    P2.Y:=yf+1;
    if Points_round then P2.Z:=round(Kontur_arr[yf+1 ,xf+1] / Factor)/10
                             else P2.Z:=round(Kontur_arr[yf+1 ,xf+1] / Factor)/100;
    P3.X:=xf;      P3.Y:=yf+1;
    if Points_round then P3.Z:=round(Kontur_arr[yf+1 ,xf  ] / Factor)/10
                             else P3.Z:=round(Kontur_arr[yf+1 ,xf  ] / Factor)/100;

    za1:=Kontur_arr[yf+1,xf]-Kontur_arr[yf,xf+1];  if za1<0 then za1:=-za1;
    za2:=Kontur_arr[yf,xf]  -Kontur_arr[yf+1,xf+1];if za2<0 then za2:=-za2;

    if za1>za2 then TriangleVar2_in_List(P0,P1,P2,P3)
               else TriangleVar1_in_List(P0,P1,P2,P3);
    end;{ENDE VON if V1<>V3 then}
  end;{ENDE VON for xf:=GL_X0 to GL_X1-1 do}
 end;{ENDE VON for yf:=GL_Y0 to GL_Y1-1 do}
end;

Procedure Quad_List_Fill;
var za1,za2,tempr,z_min:real;
    a,V1,V2,V3,V11,V22,V33,PunktEnde,merke_xs,xf,yf,xf2,xf3,yf2,wo,
    PolyL_1,PolyL_2,PolyR_1,PolyR_2:integer;
    stemp,Zahl_String:string;
    Zeile_dazu,Ende:Boolean;
    Factor:integer;
begin
 if DebugP then F_Infos.ListBox1.Items.add('OpenGL Quad_List_Fill');
{P3  ____________ P2      _________________________    za1:=P4-P2
    |           /|       |            |            |   za2:=P1-P3
    |Polygon1    |       |            |            |
    |            |      V11        V33|V1       V3 |
    |            |       |            |            |
    |   Polygon2 |       |            |            |
 P0 |/___________|P1     |__V22_______|__V2________|
                     merke_xs
 for yf:=GL_Y1 to ys2-1 do
  for xf:=GL_X1 to xs2-1 do
   begin
    _____ _
   |_____|/| Dreipoly,eventuell Balken davor
     _____ _
    |_____|_| Vierpoly,eventuell Balken davor
      _____
     |_____|   nur Balken
    end;
   end;}

 if Points_round then Factor:=Z_Factor div 10
                 else Factor:=Z_Factor div 100;
 for yf:=GL_Y0 to GL_Y1-1 do
 begin
  merke_xs:=GL_X0;
  for xf:=GL_X0 to GL_X1-1 do
  begin
   if OccupiedBit_Check(yf,xf)=0 then
   begin
    V1:=round(Kontur_arr[yf+1,xf  ]/Factor)-round(Kontur_arr[yf,xf  ]/Factor);
    V2:=round(Kontur_arr[yf  ,xf+1]/factor)-round(Kontur_arr[yf,xf  ]/Factor);
    V3:=round(Kontur_arr[yf+1,xf+1]/Factor)-round(Kontur_arr[yf,xf+1]/Factor);
    if V1<>V3 then
    begin
     if xf>merke_xs then
     begin
      PolyL_1:=0;PolyL_2:=0;
      if merke_xs>GL_X0 then
       begin
        V11:=round(Kontur_arr[yf+1,merke_xs-1]/Factor)-round(Kontur_arr[yf,merke_xs-1]/Factor);
        if V11=V1 then PolyL_1:=1 else PolyL_1:=2;
       end;
       V11:=round(Kontur_arr[yf+1,xf+1]/Factor)-round(Kontur_arr[yf,xf+1]/Factor);
       if V11=V1 then PolyR_1:=1 else PolyR_1:=2;

       Ende:=false;Yf2:=yf;Zeile_dazu:=true;
       if yf<GL_Y1-1 then
       repeat
        if yf2<GL_Y1-1 then
        begin
         inc(yf2);
         for xf2:=merke_xs to xf do
         begin
           V11:=round(Kontur_arr[yf2+1,xf2]/Factor)-round(Kontur_arr[yf2,xf2]/Factor);
           if V11<>V1 then begin Ende:=true;Zeile_dazu:=false;end ;
         end;

         if merke_xs>GL_X0 then
         begin
          V11:=round(Kontur_arr[yf2+1,merke_xs-1]/Factor)-round(Kontur_arr[yf2,merke_xs-1]/Factor);
          if V11=V1 then PolyL_2:=1 else PolyL_2:=2;
         end;
         V11:=round(Kontur_arr[yf2+1,xf+1]/Factor)-round(Kontur_arr[yf2,xf+1]/Factor);
         if V11=V1 then PolyR_2:=1 else PolyR_2:=2;
         if(PolyL_1<>PolyL_2)or(PolyR_1<>PolyR_2)then begin Ende:=true;Zeile_dazu:=false;end;

        end else Ende:=true;
         if Zeile_dazu=true then for xf3:=merke_xs to xf-1 do OccupiedBit_Set(yf2,xf3){:=1}
                            else dec(yf2);
       until ende
      else yf2:=yf;
//------------------------------------ VierPoly ----------------------------------------------------------
      P0.X:=merke_xs; P0.Y:=yf;
      if Points_round then P0.Z:=round(Kontur_arr[yf,   merke_xs] / Factor)/10
                      else P0.Z:=round(Kontur_arr[yf,   merke_xs] / Factor)/100;
      P1.X:=xf;       P1.Y:=yf;
      if Points_round then P1.Z:=round(Kontur_arr[yf,         xf] / Factor)/10
                      else P1.Z:=round(Kontur_arr[yf,         xf] / Factor)/100;
      P2.X:=xf;       P2.Y:=yf2+1;
      if Points_round then P2.Z:=round(Kontur_arr[yf2+1,      xf] / Factor)/10
                      else P2.Z:=round(Kontur_arr[yf2+1,      xf] / Factor)/100;
      P3.X:=merke_xs; P3.Y:=yf2+1;
      if Points_round then P3.Z:=round(Kontur_arr[yf2+1,merke_xs] / Factor)/10
                      else P3.Z:=round(Kontur_arr[yf2+1,merke_xs] / Factor)/100;
      Quad_in_List(P0,P1,P2,P3);
      if Disk_arr[yf,merke_xs]   =-1 then Disk_arr[yf,merke_xs]   :=0;
      if Disk_arr[yf,xf]         =-1 then Disk_arr[yf,xf]         :=0;
      if Disk_arr[yf2+1,xf]      =-1 then Disk_arr[yf2+1,xf]      :=0;
      if Disk_arr[yf2+1,merke_xs]=-1 then Disk_arr[yf2+1,merke_xs]:=0;
     end;
//-------------------------------- 2 mal DreiPoly --------------------------------------------------------
//-------------------------------- bereits erzeugt in Triangle_Liste -------------------------------------
       if Disk_arr[yf,xf]    =-1 then Disk_arr[yf,xf]    :=0;
       if Disk_arr[yf,xf+1]  =-1 then Disk_arr[yf,xf+1]  :=0;
       if Disk_arr[yf+1,xf+1]=-1 then Disk_arr[yf+1,xf+1]:=0;
       if Disk_arr[yf+1,xf]  =-1 then Disk_arr[yf+1,xf]  :=0;
    merke_xs:=xf+1;
  end else
//-------------------------------- Vierpoly --------------------------------------------------------------
  begin
    if xf=0 then V22:=V2
            else V22:=round(Kontur_arr[yf,xf]/Factor)-round(Kontur_arr[yf,xf-1]/Factor);
    if V2<>V22 then
    begin
      if xf>merke_xs then
      begin
//-------------------------------- Balken vor Vierpoly ? --------------------------------------------------
        PolyL_1:=0;PolyL_2:=0;
        if merke_xs>GL_X0 then
        begin
        V11:=round(Kontur_arr[yf+1,merke_xs-1]/Factor)-round(Kontur_arr[yf,merke_xs-1]/Factor);
        if V11=V1 then PolyL_1:=1 else PolyL_1:=2;
        end;
        V11:=round(Kontur_arr[yf+1,xf+1]/Factor)-round(Kontur_arr[yf,xf+1]/Factor);
        if V11=V1 then PolyR_1:=1 else PolyR_1:=2;

        Ende:=false;Yf2:=yf;Zeile_dazu:=true;
        if yf<GL_Y1-1 then
        repeat
          if yf2<GL_Y1-1 then
          begin
            inc(yf2);
            for xf2:=merke_xs to xf do
            begin
              V11:=round(Kontur_arr[yf2+1,xf2]/Factor)-round(Kontur_arr[yf2,xf2]/Factor);
              if V11<>V1 then begin Ende:=true;Zeile_dazu:=false;end;
            end;

            if merke_xs>GL_X0 then
            begin
            V11:=round(Kontur_arr[yf2+1,merke_xs-1]/Factor)-round(Kontur_arr[yf2,merke_xs-1]/Factor);
            if V11=V1 then PolyL_2:=1 else PolyL_2:=2;
            end;
            V11:=round(Kontur_arr[yf2+1,xf+1]/Factor)-round(Kontur_arr[yf2,xf+1]/Factor);
            if V11=V1 then PolyR_2:=1 else PolyR_2:=2;
            if(PolyL_1<>PolyL_2)or(PolyR_1<>PolyR_2)then begin Ende:=true;Zeile_dazu:=false;end;

          end else Ende:=true;
          if Zeile_dazu=true then for xf3:=merke_xs to xf-1  do OccupiedBit_Set(yf2,xf3){:=1}
                             else dec(yf2);
        until ende=true
        else yf2:=yf;
//------------------------------------ Polygon und Punkte ------------------------------------------------
      P0.X:=merke_xs; P0.Y:=yf;
      if Points_round then P0.Z:=round(Kontur_arr[yf,   merke_xs] / Factor)/10
                      else P0.Z:=round       (Kontur_arr[yf,   merke_xs] / Factor)/100;
      P1.X:=xf;       P1.Y:=yf;
      if Points_round then P1.Z:=round(Kontur_arr[yf,         xf] / Factor)/10
                      else P1.Z:=round       (Kontur_arr[yf,         xf] / Factor)/100;
      P2.X:=xf;       P2.Y:=yf2+1;
      if Points_round then P2.Z:=round(Kontur_arr[yf2+1,      xf] / Factor)/10
                      else P2.Z:=round       (Kontur_arr[yf2+1,      xf] / Factor)/100;
      P3.X:=merke_xs; P3.Y:=yf2+1;
      if Points_round then P3.Z:=round(Kontur_arr[yf2+1,merke_xs] / Factor)/10
                      else P3.Z:=round       (Kontur_arr[yf2+1,merke_xs] / Factor)/100;
      Quad_in_List(P0,P1,P2,P3);
      if Disk_arr[yf,merke_xs]   =-1 then Disk_arr[yf,merke_xs]:=0;
      if Disk_arr[yf,xf]         =-1 then Disk_arr[yf,xf]      :=0;
      if Disk_arr[yf2+1,xf]      =-1 then Disk_arr[yf2+1,xf]   :=0;
      if Disk_arr[yf2+1,merke_xs]=-1 then Disk_arr[yf2+1,merke_xs]  :=0;

    end;
//-------------------------------- 1 mal Vierpoly --------------------------------------------------------
      if (xf=GL_X1-1)or(OccupiedBit_Check(yf,xf+1)=1)then
      begin

        PolyL_1:=0;PolyL_2:=0;PolyR_1:=0;PolyR_2:=0;
        if xf>GL_X0 then
        begin
        V11:=round(Kontur_arr[yf+1,xf-1]/Factor)-round(Kontur_arr[yf,xf-1]/Factor);
        if V11=V1 then PolyL_1:=1 else PolyL_1:=2;
        end;
        if xf<GL_X1-1 then
        begin
        V11:=round(Kontur_arr[yf+1,xf+2]/Factor)-round(Kontur_arr[yf,xf+2]/Factor);
        if V11=V1 then PolyR_1:=1 else PolyR_1:=2;
        end;
        Ende:=false;Yf2:=yf;Zeile_dazu:=true;
        if yf<GL_Y1-1 then
        repeat
          if yf2<GL_Y1-1 then
          begin
            inc(yf2);
            for xf2:=xf to xf+1 do
            begin
              V11:=round(Kontur_arr[yf2+1,xf2]/Factor)-round(Kontur_arr[yf2,xf2]/Factor);
              if V11<>V1 then begin Ende:=true;Zeile_dazu:=false;end;
            end;

            if xf>GL_X0 then
            begin
            V11:=round(Kontur_arr[yf2+1,xf-1]/Factor)-round(Kontur_arr[yf2,xf-1]/Factor);
            if V11=V1 then PolyL_2:=1 else PolyL_2:=2;
            end;
            if xf<GL_X1-1 then
            begin
            V11:=round(Kontur_arr[yf2+1,xf+2]/Factor)-round(Kontur_arr[yf2,xf+2]/Factor);
            if V11=V1 then PolyR_2:=1 else PolyR_2:=2;
            end;
            if(PolyL_1<>PolyL_2)or(PolyR_1<>PolyR_2)then begin Ende:=true;Zeile_dazu:=false;end;

          end else Ende:=true;
          if Zeile_dazu=true then OccupiedBit_Set(yf2,xf){:=1}
                             else dec(yf2);

        until ende=true
        else yf2:=yf;
//------------------------------------ Polygon und Punkte ------------------------------------------------
      P0.X:=xf;      P0.Y:=yf;
      if Points_round then P0.Z:=round(Kontur_arr[yf,         xf] / Factor)/10
                      else P0.Z:=round     (Kontur_arr[yf,         xf] / Factor)/100;
      P1.X:=xf+1;    P1.Y:=yf;
      if Points_round then P1.Z:=round(Kontur_arr[yf,       xf+1] / Factor)/10
                      else P1.Z:=round     (Kontur_arr[yf,       xf+1] / Factor)/100;
      P2.X:=xf+1;    P2.Y:=yf2+1;
      if Points_round then P2.Z:=round(Kontur_arr[yf2+1,    xf+1] / Factor)/10
                      else P2.Z:=round     (Kontur_arr[yf2+1,    xf+1] / Factor)/100;
      P3.X:=xf;      P3.Y:=yf2+1;
      if Points_round then P3.Z:=round(Kontur_arr[yf2+1,      xf] / Factor)/10
                      else P3.Z:=round     (Kontur_arr[yf2+1,      xf] / Factor)/100;
      Quad_in_List(P0,P1,P2,P3);
      if Disk_arr[yf,xf]     =-1 then Disk_arr[yf,xf]     :=0;
      if Disk_arr[yf,xf+1]   =-1 then Disk_arr[yf,xf+1]   :=0;
      if Disk_arr[yf2+1,xf+1]=-1 then Disk_arr[yf2+1,xf+1]:=0;
      if Disk_arr[yf2+1,xf]  =-1 then Disk_arr[yf2+1,xf]  :=0;
    end;
        merke_xs:=xf;
    end else
    begin
//================================ Balken ================================================================
    if (xf=GL_X1-1)or(OccupiedBit_Check(yf,xf+1)=1)then
      begin

      PolyL_1:=0;PolyL_2:=0;
      if merke_xs>GL_X0 then
      begin
        V11:=round(Kontur_arr[yf+1,merke_xs-1]/Factor)-round(Kontur_arr[yf,merke_xs-1]/Factor);
        if V11=V1 then PolyL_1:=1 else PolyL_1:=2;
      end;
      V11:=round(Kontur_arr[yf+1,xf+1]/Factor)-round(Kontur_arr[yf,xf+1]/Factor);
      if V11=V1 then PolyR_1:=1 else PolyR_1:=2;

        Ende:=false;Yf2:=yf;Zeile_dazu:=true;
        if yf<GL_Y1-1 then
        repeat
          if yf2<GL_Y1-1 then
          begin
            inc(yf2);
            for xf2:=merke_xs to xf+1 do
            begin
              V11:=round(Kontur_arr[yf2+1,xf2]/Factor)-round(Kontur_arr[yf2,xf2]/Factor);
              if V11<>V1 then begin Ende:=true;Zeile_dazu:=false;end;
            end;

            if merke_xs>GL_X0 then
            begin
              V11:=round(Kontur_arr[yf2+1,merke_xs-1]/Factor)-round(Kontur_arr[yf2,merke_xs-1]/Factor);
              if V11=V1 then PolyL_2:=1 else PolyL_2:=2;
            end;
            V11:=round(Kontur_arr[yf2+1,xf+1]/Factor)-round(Kontur_arr[yf2,xf+1]/Factor);
            if V11=V1 then PolyR_2:=1 else PolyR_2:=2;
            if(PolyL_1<>PolyL_2)or(PolyR_1<>PolyR_2)then begin Ende:=true;Zeile_dazu:=false;end;

          end else Ende:=true;
          if Zeile_dazu=true then for xf3:=merke_xs to xf do OccupiedBit_Set(yf2,xf3){:=1}
                             else dec(yf2);
        until ende=true
        else yf2:=yf;
//------------------------------------ Polygon und Punkte ------------------------------------------------
      P0.X:=merke_xs; P0.Y:=yf;
      if Points_round then P0.Z:=round(Kontur_arr[yf,   merke_xs] / Factor)/10
                      else P0.Z:=round(Kontur_arr[yf,   merke_xs] / Factor)/100;
      P1.X:=xf+1;     P1.Y:=yf;
      if Points_round then P1.Z:=round(Kontur_arr[yf,       xf+1] / Factor)/10
                      else P1.Z:=round(Kontur_arr[yf,       xf+1] / Factor)/100;
      P2.X:=xf+1;     P2.Y:=yf2+1;
      if Points_round then P2.Z:=round(Kontur_arr[yf2+1,    xf+1] / Factor)/10
                      else P2.Z:=round(Kontur_arr[yf2+1,    xf+1] / Factor)/100;
      P3.X:=merke_xs; P3.Y:=yf2+1;
      if Points_round then P3.Z:=round(Kontur_arr[yf2+1,merke_xs] / Factor)/10
                      else P3.Z:=round(Kontur_arr[yf2+1,merke_xs] / Factor)/100;
      Quad_in_List(P0,P1,P2,P3);
      if Disk_arr[yf,merke_xs]   =-1 then Disk_arr[yf,merke_xs]   :=0;
      if Disk_arr[yf,xf+1]       =-1 then Disk_arr[yf,xf+1]       :=0;
      if Disk_arr[yf2+1,xf+1]    =-1 then Disk_arr[yf2+1,xf+1]    :=0;
      if Disk_arr[yf2+1,merke_xs]=-1 then Disk_arr[yf2+1,merke_xs]:=0;
    end;
    end;
  end;

   end else merke_xs:=xf+1;
  end;  {Ende xschleife}
 end;  {Ende yschleife}
end;

Procedure Point_List_Fill;
var xf,yf:integer;
    Factor:integer;
begin
 if DebugP then F_Infos.ListBox1.Items.add('OpenGL Point_List_Fill');
 Z_Down:=10000;Z_Top:=-10000;
 if Points_round then Factor:=Z_Factor div 10
                          else Factor:=Z_Factor div 100;
 for yf:=GL_Y0 to GL_Y1 do for xf:=GL_X0 to GL_X1 do
 begin
  if Disk_arr[yf,xf]=0 then
  begin
   P0.X:=xf;P0.Y:=yf;
   if Points_round then P0.Z:=round(Kontur_arr[yf,xf] / Factor)/10
                            else P0.Z:=round(Kontur_arr[yf,xf] / Factor)/100;
   if P0.Z<Z_Down then Z_Down:=P0.Z
                   else if P0.Z>Z_Top then Z_Top:=P0.Z;
   Point_in_List(P0);
  end;
 end;
end;

Procedure Bound_List_Fill;
begin
 if DebugP then F_Infos.ListBox1.Items.add('OpenGL Bound_List_Fill');
     glVertex3f(GL_X0,GL_Y0,Z_Top);
     glVertex3f(GL_X1,GL_Y0,Z_Top);
     glVertex3f(GL_X1,GL_Y0,Z_Top);
     glVertex3f(GL_X1,GL_Y1,Z_Top);
     glVertex3f(GL_X1,GL_Y1,Z_Top);
     glVertex3f(GL_X0,GL_Y1,Z_Top);
     glVertex3f(GL_X0,GL_Y1,Z_Top);
     glVertex3f(GL_X0,GL_Y0,Z_Top);
     glVertex3f(GL_X0,GL_Y0,Z_Down);
     glVertex3f(GL_X1,GL_Y0,Z_Down);
     glVertex3f(GL_X1,GL_Y0,Z_Down);
     glVertex3f(GL_X1,GL_Y1,Z_Down);
     glVertex3f(GL_X1,GL_Y1,Z_Down);
     glVertex3f(GL_X0,GL_Y1,Z_Down);
     glVertex3f(GL_X0,GL_Y1,Z_Down);
     glVertex3f(GL_X0,GL_Y0,Z_Down);
     glVertex3f(GL_X0,GL_Y0,Z_Top);
     glVertex3f(GL_X0,GL_Y0,Z_Down);
     glVertex3f(GL_X1,GL_Y0,Z_Top);
     glVertex3f(GL_X1,GL_Y0,Z_Down);
     glVertex3f(GL_X1,GL_Y1,Z_Top);
     glVertex3f(GL_X1,GL_Y1,Z_Down);
     glVertex3f(GL_X0,GL_Y1,Z_Top);
     glVertex3f(GL_X0,GL_Y1,Z_Down);
end;

{Procedure Material_List_Fill;
begin
 if DebugP then F_Infos.ListBox1.Items.add('OpenGL Material_List_Fill');
 glDisable(GL_LIGHTING);
 glEnable(GL_LINE_STIPPLE);
 glLineStipple(1, 58596);     //1234567890123456
 glColor3f(1.0,1.0,1.0);     //1110010011100100
 glBegin(GL_LINE_STRIP);
     glVertex3f(xmin*scalf,ymin*scalf,zmin*scalf);
     glVertex3f(xmax*scalf,ymin*scalf,zmin*scalf);
     glVertex3f(xmax*scalf,ymax*scalf,zmin*scalf);
     glVertex3f(xmin*scalf,ymax*scalf,zmin*scalf);
     glVertex3f(xmin*scalf,ymin*scalf,zmin*scalf);

     glVertex3f(xmin*scalf,ymin*scalf,znp*scalf);
     glVertex3f(xmax*scalf,ymin*scalf,znp*scalf);
     glVertex3f(xmax*scalf,ymax*scalf,znp*scalf);
     glVertex3f(xmin*scalf,ymax*scalf,znp*scalf);
     glVertex3f(xmin*scalf,ymin*scalf,znp*scalf);
 glEnd;
 glBegin(GL_LINES);
     glVertex3f(xmax*scalf,ymin*scalf,zmin*scalf);  glVertex3f(xmax*scalf,ymin*scalf,znp*scalf);
     glVertex3f(xmax*scalf,ymax*scalf,zmin*scalf);  glVertex3f(xmax*scalf,ymax*scalf,znp*scalf);
     glVertex3f(xmin*scalf,ymax*scalf,zmin*scalf);  glVertex3f(xmin*scalf,ymax*scalf,znp*scalf);
 glEnd;
 glDisable(GL_LINE_STIPPLE);
end;}
//-------------------------- Listen fllen aufrufen ------------------------------------------------------
Procedure List_Fill_Call;
var xf,yf:integer;
begin
 if (GL_X1-GL_X0>1)and(GL_Y1-GL_Y0>1)then
 begin
  for yf:=GL_Y0 to GL_Y1 do for xf:=GL_X0 to GL_X1 do Disk_arr[yf,xf]:=-1;
  for yf:=0 to Kontur_ArrEnd do for xf:=0 to Bit_arrEnd do OccupiedBit_arr[yf,xf]:=0;
  PolyZahl:=0;

//Block Dreieck Liste
  if glIsList(Triangle_List)=TRUE then glDeleteLists(Triangle_List,2);//falls vorhanden dann lschen
  glNewList(Triangle_List,GL_Compile);
    glbegin(gl_triangles);
      Triangle_List_Fill;
    glend;
  glEndList();
//Block Viereck Liste
  if glIsList(Quad_List)=TRUE then glDeleteLists(Quad_List,3);//falls vorhanden dann lschen
  glNewList(Quad_List,GL_Compile);
    glBegin(gl_quads);
      Quad_List_Fill;
    glend;
  glEndList();
//Block Punkte Liste
  if glIsList(Point_List)=TRUE then glDeleteLists(Point_List,1);//falls vorhanden dann lschen
  glNewList(Point_List,GL_Compile);
    glbegin(gl_Points);
      Point_List_Fill;
    glend;
  glEndList();
//Block Quader Liste
  if glIsList(Bound_List)=TRUE then glDeleteLists(Bound_List,4);//falls vorhanden dann lschen
  glNewList(Bound_List, GL_Compile);
    glBegin(GL_LINES);
      Bound_List_Fill;
    glEnd;
  glEndList();
//Block Rohmaterial Liste
{  if glIsList(Material_List)=TRUE then glDeleteLists(Material_List,5);//falls vorhanden dann lschen
  glNewList(Material_List, GL_Compile);
      Material_List_Fill;
  glEndList();}
 end;
end;

end.
