unit U_RegionEditor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TF_RegionEditor = class(TForm)
    CheckBox1: TCheckBox;
    ComboBox1: TComboBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Edit5: TEdit;
    Label6: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure SetLabels;
    Function Read_in_Rec:boolean;
  public
    { Public-Deklarationen }
  end;

var
  F_RegionEditor: TF_RegionEditor;

type Region_rec = record
        active:boolean;
        Typ:integer;
        x1:real;
        y1:real;
        x2:real;
        y2:real;
        z:real;
        end;
var Region_arr: array[1..10]of Region_rec;


implementation

uses U_2DFenster, U_ZeileLesen;

{$R *.DFM}

procedure TF_RegionEditor.FormCreate(Sender: TObject);
var a:integer;
begin
 for a:=1 to 10 do
 begin
   Region_arr[a].active:=false;
   Region_arr[a].Typ:=0;
   Region_arr[a].x1:=0;
   Region_arr[a].y1:=0;
   Region_arr[a].x2:=1;
   Region_arr[a].y2:=1;
   Region_arr[a].z :=0;
 end;
end;

Function TF_RegionEditor.Read_in_Rec:boolean;
var a:integer;
begin
 a:=StrToIntDef(ComboBox1.Text,0);
 if (a>0)and(a<11)then
 begin
   Region_arr[a].active:=CheckBox1.Checked;
   if RadioButton1.Checked then Region_arr[a].Typ:=0 else
   if RadioButton2.Checked then Region_arr[a].Typ:=1;
   Region_arr[a].x1:=StrToFloat(Edit1.Text);
   Region_arr[a].y1:=StrToFloat(Edit2.Text);
   Region_arr[a].x2:=StrToFloat(Edit3.Text);
   Region_arr[a].y2:=StrToFloat(Edit4.Text);
   Region_arr[a].z :=StrToFloat(Edit5.Text);
   F_2D.New_Region_show;
   Result:=true;
 end else
 begin
   MessageDlg('Bereichsnummer fehlerhaft', mtError,[mbOk], 0);
   Result:=false;
 end;
end;

procedure TF_RegionEditor.Button1Click(Sender: TObject);
begin
 if Read_in_Rec then
 begin
   F_2D.New_Region_show;
   Close;
 end;
end;

procedure TF_RegionEditor.Button2Click(Sender: TObject);
var a:integer;
begin
 if Read_in_Rec then F_2D.New_Region_show;
end;

procedure TF_RegionEditor.Button3Click(Sender: TObject);
begin Close;
end;

procedure TF_RegionEditor.RadioButton1Click(Sender: TObject);
begin
 SetLabels;
end;

procedure TF_RegionEditor.RadioButton2Click(Sender: TObject);
begin
 setLabels;
end;

procedure TF_RegionEditor.SetLabels;
begin
 if RadioButton1.checked then
 begin
  Label1.Caption:='X1';
  Label2.Caption:='Y1';
  Label3.Caption:='X2';
  Label4.Visible:=true;
  Edit4.Visible:=true;
 end else
 begin
  Label1.Caption:='X';
  Label2.Caption:='Y';
  Label3.Caption:='Radius';
  Label4.Visible:=false;
  Edit4.Visible:=false;
 end;
end;

procedure TF_RegionEditor.ComboBox1Change(Sender: TObject);
var a:integer;
begin
 a:=StrToIntDef(ComboBox1.Text,0);
 if (a>0)and(a<11)then
 begin
   F_RegionEditor.Caption:='Bereich '+intToStr(a);
   CheckBox1.Checked:=Region_arr[a].active;
   if Region_arr[a].Typ=0 then RadioButton1.Checked:=true else
   if Region_arr[a].Typ=1 then RadioButton2.Checked:=true ;
   Edit1.Text:=FloatToStrF(Region_arr[a].x1,ffFixed,15,2);
   Edit2.Text:=FloatToStrF(Region_arr[a].y1,ffFixed,15,2);
   Edit3.Text:=FloatToStrF(Region_arr[a].x2,ffFixed,15,2);
   Edit4.Text:=FloatToStrF(Region_arr[a].y2,ffFixed,15,2);
   Edit5.Text:=FloatToStrF(Region_arr[a].z ,ffFixed,15,2);
 end;
end;

end.
