unit U_ToolTable;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Grids;

type
  TF_ToolTable = class(TForm)
    StringGrid1: TStringGrid;
    procedure FormShow(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    Procedure TableShow;
    Procedure TableClear;
  end;

var
  F_ToolTable: TF_ToolTable;

implementation

uses U_2DFenster, U_Infos, U_ZeileLesen, U_ReadToolFile;

{$R *.DFM}

Procedure TF_ToolTable.TableClear;
var a:cardinal;
begin
 with StringGrid1 do
 begin
   RowCount:=2;
   for a:=0 to 11 do Cells[a,1] := '';
 end;
end;

Procedure TF_ToolTable.TableShow;
var a,b:cardinal;
    sTyp:string;
    bShow:boolean;
begin
 bShow:=false;
 b:=1;
 for a:=1 to 100 do
 begin
   if ToolTab[a].use then
   begin
     if ToolTab[a].Typ=0  then sTyp:=''   else
     if ToolTab[a].Typ=1  then sTyp:='Plankopf'          else
     if ToolTab[a].Typ=2  then sTyp:='Zylinderfrser'    else
     if ToolTab[a].Typ=3  then sTyp:='Kugelfrser'       else
     if ToolTab[a].Typ=4  then sTyp:='Radienfrser auen'else
     if ToolTab[a].Typ=10 then sTyp:='Stichel'           else
     if ToolTab[a].Typ=20 then sTyp:='Anbohrer'          else
     if ToolTab[a].Typ=21 then sTyp:='Zentrierbohrer'    else
     if ToolTab[a].Typ=22 then sTyp:='Bohrer'            else
     if ToolTab[a].Typ=23 then sTyp:='Reibahle';
     with StringGrid1 do
     begin
       RowCount:=b+1;
       Cells[0,b] := IntToStr(a);
       Cells[1,b] := sTyp;
       if ToolTab[a].D =0  then Cells[2,b]:=''
                           else Cells[2,b]:=FloatToStrF(ToolTab[a].D*2,ffFixed,15,2);
       if ToolTab[a].R =0  then Cells[3,b]:=''
                           else Cells[3,b]:=FloatToStrF(ToolTab[a].R,ffFixed,15,2);
       if ToolTab[a].Grad =0 then Cells[4,b]:=''
                             else Cells[4,b]:=FloatToStrF(ToolTab[a].Grad,ffFixed,15,2);
       if ToolTab[a].GT=0  then Cells[5,b]:=''
                           else Cells[5,b]:=FloatToStrF(ToolTab[a].GT,ffFixed,15,2);
       if ToolTab[a].GSL=0 then Cells[7,b]:=''
                           else Cells[7,b]:=FloatToStrF(ToolTab[a].GSL,ffFixed,15,2);

       if ToolTab[a].GT=0
       then Cells[6,b]:= FloatToStrF(ToolTab[a].GTist/Z_Factor/scalf,ffFixed,15,2)
       else
         if round(ToolTab[a].GTist/Z_Factor/scalf*100) > round(ToolTab[a].GT*100)
         then
         begin Cells[6,b]:= FloatToStrF(ToolTab[a].GTist/Z_Factor/scalf,ffFixed,15,2)+' ';
               bshow:=true;
               Over_Tool_length:=true;
         end
         else Cells[6,b]:= FloatToStrF(ToolTab[a].GTist/Z_Factor/scalf,ffFixed,15,2);

       if ToolTab[a].GSL=0
       then Cells[8,b]:= FloatToStrF(ToolTab[a].GSList/Z_Factor/scalf,ffFixed,15,2)
       else
         if round(ToolTab[a].GSList/Z_Factor/scalf*100) > round(ToolTab[a].GSL*100)
         then
         begin Cells[8,b]:= FloatToStrF(ToolTab[a].GSList/Z_Factor/scalf,ffFixed,15,2)+' ';
               bshow:=true;
               Over_cut_length:=true;
         end
         else Cells[8,b]:= FloatToStrF(ToolTab[a].GSList/Z_Factor/scalf,ffFixed,15,2);
       //F default 700, S 3000 default
       if ToolTab[a].Fmax= 0 then
       begin Cells[9,b]:='0 ';
             bshow:=true;
       end else Cells[9,b]:= FloatToStrF(ToolTab[a].Fmax,ffFixed,15,0);
       if ToolTab[a].Fmin= 0 then
       begin Cells[10,b]:='0 ';
             bshow:=true;
       end else Cells[10,b]:= FloatToStrF(ToolTab[a].Fmin,ffFixed,15,0);

       if ToolTab[a].Smax= 0 then
       begin Cells[11,b]:='0 ';
             bshow:=true;
       end else Cells[11,b]:= FloatToStrF(ToolTab[a].Smax,ffFixed,15,0);
       if ToolTab[a].Smin= 0 then
       begin Cells[12,b]:='0 ';
             bshow:=true;
       end else Cells[12,b]:= FloatToStrF(ToolTab[a].Smin,ffFixed,15,0);

       if ToolTab[a].FSdef then
       begin Cells[13,b]:='x ';
             bshow:=true;
       end else Cells[13,b]:='';

       if ToolTab[a].G0max= 0 then Cells[14,b]:='' else
       begin
         Cells[14,b]:= FloatToStrF(ToolTab[a].G0max/Z_Factor/scalf,ffFixed,15,2)+' ';
         bshow:=true;
       end;
       Cells[15,b]:=ToolTab[a].Info;
       inc(b);
     end;
   end;
 end;
 if bShow then Show;
end;

procedure TF_ToolTable.StringGrid1DrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var st:string;
    {a,fn:integer;}
begin
  with Sender as TDrawGrid do
  begin
    if aRow=0 then Canvas.Brush.Color := clgray else
    begin
      st:=StringGrid1.cells[aCol,aRow];
      {fn:=0;
      for a:= length(st) downto 1 do if st[a]= ' 'then inc(fn);
      if fn = 0 then Canvas.Brush.Color := clWindow else
      if fn = 1 then Canvas.Brush.Color := clRed else
      if fn = 2 then Canvas.Brush.Color := clGreen;}
      if length(st)=0 then Canvas.Brush.Color := clWindow else
      if st[length(st)]=' ' then Canvas.Brush.Color := clRed
                            else Canvas.Brush.Color := clWindow;
    end;
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left+2,Rect.Top+1,StringGrid1.cells[aCol,aRow]);
  end;
end;

procedure TF_ToolTable.FormShow(Sender: TObject);
var xlinks,xrechts,yoben,breite,xScreen:integer;
begin
 xscreen:=GetSystemMetrics(SM_CXSCREEN);
 xlinks:=F_2D.Left;
 xrechts:=xlinks+F_2D.width;
 yoben:=F_2D.Top;if yoben<0 then yoben:=0;
 breite:=F_ToolTable.Width;
 if xrechts+breite< xscreen then
 begin  F_ToolTable.Left:=xrechts;F_ToolTable.top:=yoben;
 end else
 if xlinks>breite then
 begin  F_ToolTable.Left:=xlinks-breite;F_ToolTable.top:=yoben;
 end else
 begin  F_ToolTable.Left:=xlinks+2;F_ToolTable.top:=yoben;
 end;
 StringGrid1.ColWidths[0] :=24;  StringGrid1.Cells[0,0] :='Nr';
 StringGrid1.ColWidths[1] :=70;  StringGrid1.Cells[1,0] :='Typ';
 StringGrid1.ColWidths[2] :=50;  StringGrid1.Cells[2,0] :='Durch.';
 StringGrid1.ColWidths[3] :=50;  StringGrid1.Cells[3,0] :='Radius';
 StringGrid1.ColWidths[4] :=50;  StringGrid1.Cells[4,0] :='Grad';
 StringGrid1.ColWidths[5] :=50;  StringGrid1.Cells[5,0] :='GT';
 StringGrid1.ColWidths[6] :=50;  StringGrid1.Cells[6,0] :='GT max';
 StringGrid1.ColWidths[7] :=50;  StringGrid1.Cells[7,0] :='GSL';
 StringGrid1.ColWidths[8] :=50;  StringGrid1.Cells[8,0] :='GSL max';
 StringGrid1.ColWidths[9] :=50;  StringGrid1.Cells[9,0] :='F max';
 StringGrid1.ColWidths[10]:=50;  StringGrid1.Cells[10,0]:='F min';
 StringGrid1.ColWidths[11]:=50;  StringGrid1.Cells[11,0]:='S max';
 StringGrid1.ColWidths[12]:=50;  StringGrid1.Cells[12,0]:='S min';
 StringGrid1.ColWidths[13]:=50;  StringGrid1.Cells[13,0]:='FS def';
 StringGrid1.ColWidths[14]:=50;  StringGrid1.Cells[14,0]:='G0 max';
 StringGrid1.ColWidths[15]:=100; StringGrid1.Cells[15,0]:='Info';
end;

end.
